//+------------------------------------------------------------------+
//|                                             money-management.mq5 |
//|                                                           andrea |
//+------------------------------------------------------------------+
#property copyright "andrea"

class MoneyManagement{

   private:
   
      double lots;
      
   
   public:
      
      double getLots(){
         return lots;
      }
      
      void setLotsByStopLossAndRiskPercentage(double riskPercentage, int stopLossInPoints){
      
         double pipValue = SymbolInfoDouble(Symbol(), SYMBOL_TRADE_TICK_VALUE);
         double accountBalance = AccountInfoDouble(ACCOUNT_BALANCE);
         double maxRiskInPrice = accountBalance * (riskPercentage / 100);
         
         lots = maxRiskInPrice  / (pipValue * stopLossInPoints) ; 
         lots = floor(lots * 100) / 100; 
         
         if( lots > SymbolInfoDouble(Symbol(), SYMBOL_VOLUME_MAX) ){
            lots = SymbolInfoDouble(Symbol(), SYMBOL_VOLUME_MAX);
         }else if( lots < SymbolInfoDouble(Symbol(), SYMBOL_VOLUME_MIN) ){
            printf("Error: minimum lots not excedeed");
         }
         
         //printf("accountBalance=" + accountBalance + " maxRiskInPrice=" + maxRiskInPrice + " riskPercentage=" + riskPercentage  + " pipValue=" + pipValue + " stopLossInPoints=" + stopLossInPoints + "  lots=" + lots );
         
      }
   
};